<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Accessories: ActionsStack Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Accessories
   </div>
   <div id="projectbrief">Arduino for motors and lights library.</div>
  </td>
   <td>        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
</td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('classActionsStack.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-attribs">Static Public Attributes</a> &#124;
<a href="classActionsStack-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">ActionsStack Class Reference</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">

<p><code>#include &quot;<a class="el" href="ActionsStack_8hpp_source.html">ActionsStack.hpp</a>&quot;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ace063540984142614a5e6db58a3d9edd"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classActionsStack.html#ace063540984142614a5e6db58a3d9edd">ActionsStack</a> (int inSize)</td></tr>
<tr class="separator:ace063540984142614a5e6db58a3d9edd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a12c3702836732893421ef6a75c504eda"><td class="memItemLeft" align="right" valign="top">unsigned char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classActionsStack.html#a12c3702836732893421ef6a75c504eda">Add</a> (unsigned long inId, ACCESSORIES_EVENT_TYPE inEvent, int inData = 0)</td></tr>
<tr class="separator:a12c3702836732893421ef6a75c504eda"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a92c898ac34971204c6da70234a9cd568"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classAction.html">Action</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classActionsStack.html#a92c898ac34971204c6da70234a9cd568">operator[]</a> (unsigned char idx)</td></tr>
<tr class="separator:a92c898ac34971204c6da70234a9cd568"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7206851ec4f6accf0feafeb60000e2e5"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classActionsStack.html#a7206851ec4f6accf0feafeb60000e2e5">Clear</a> ()</td></tr>
<tr class="separator:a7206851ec4f6accf0feafeb60000e2e5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7ab206f5490b5169845ecf5ccef17ca9"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classActionsStack.html#a7ab206f5490b5169845ecf5ccef17ca9">Delete</a> (int inIndex)</td></tr>
<tr class="separator:a7ab206f5490b5169845ecf5ccef17ca9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae5e923c8c890313fe9fe67fae9497562"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classAction.html">Action</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classActionsStack.html#ae5e923c8c890313fe9fe67fae9497562">GetActionToExecute</a> ()</td></tr>
<tr class="separator:ae5e923c8c890313fe9fe67fae9497562"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2ba3fc8906482ba474a1034a81d443c6"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classActionsStack.html#a2ba3fc8906482ba474a1034a81d443c6">GetNumber</a> () const </td></tr>
<tr class="separator:a2ba3fc8906482ba474a1034a81d443c6"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-attribs"></a>
Static Public Attributes</h2></td></tr>
<tr class="memitem:a458994617bfbd0f8aee0fb93abcdb347"><td class="memItemLeft" align="right" valign="top">static ActionsStack&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classActionsStack.html#a458994617bfbd0f8aee0fb93abcdb347">Actions</a></td></tr>
<tr class="separator:a458994617bfbd0f8aee0fb93abcdb347"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aef1d9742f23cad44c4e85e0cfdf942e9"><td class="memItemLeft" align="right" valign="top">static bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classActionsStack.html#aef1d9742f23cad44c4e85e0cfdf942e9">FillingStack</a></td></tr>
<tr class="separator:aef1d9742f23cad44c4e85e0cfdf942e9"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This class is a small list of available actions. When the stack reach the size, new actions are lost... </p>

<p class="definition">Definition at line <a class="el" href="ActionsStack_8hpp_source.html#l00031">31</a> of file <a class="el" href="ActionsStack_8hpp_source.html">ActionsStack.hpp</a>.</p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="ace063540984142614a5e6db58a3d9edd"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">ActionsStack::ActionsStack </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>inSize</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Default constructor. </p>

<p class="definition">Definition at line <a class="el" href="ActionsStack_8cpp_source.html#l00019">19</a> of file <a class="el" href="ActionsStack_8cpp_source.html">ActionsStack.cpp</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a12c3702836732893421ef6a75c504eda"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned char ActionsStack::Add </td>
          <td>(</td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>inId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">ACCESSORIES_EVENT_TYPE&#160;</td>
          <td class="paramname"><em>inEvent</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>inData</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><a class="el" href="classActionsStack.html#a12c3702836732893421ef6a75c504eda">Add</a> a new action. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">inId</td><td>Id of the accessory </td></tr>
    <tr><td class="paramname">inEvent</td><td>Event type </td></tr>
    <tr><td class="paramname">inData</td><td>Associated data for this event. Default is 0. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Index of the new action or 'size of the stack+1' if the stack is full. </dd></dl>
<dl class="section remark"><dt>Remarks</dt><dd>If the stack is full, this event will be lost. </dd></dl>

<p class="definition">Definition at line <a class="el" href="ActionsStack_8cpp_source.html#l00031">31</a> of file <a class="el" href="ActionsStack_8cpp_source.html">ActionsStack.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="a7206851ec4f6accf0feafeb60000e2e5"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void ActionsStack::Clear </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Clears the complete stack. </p>

<p class="definition">Definition at line <a class="el" href="ActionsStack_8cpp_source.html#l00071">71</a> of file <a class="el" href="ActionsStack_8cpp_source.html">ActionsStack.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="a7ab206f5490b5169845ecf5ccef17ca9"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void ActionsStack::Delete </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>inIndex</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Remove the given index of the stack. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">inIndex</td><td>index to clear. </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="ActionsStack_8cpp_source.html#l00061">61</a> of file <a class="el" href="ActionsStack_8cpp_source.html">ActionsStack.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="ae5e923c8c890313fe9fe67fae9497562"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classAction.html">Action</a> * ActionsStack::GetActionToExecute </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Get an action to execute. </p><dl class="section return"><dt>Returns</dt><dd>action address or NULL </dd></dl>

<p class="definition">Definition at line <a class="el" href="ActionsStack_8cpp_source.html#l00045">45</a> of file <a class="el" href="ActionsStack_8cpp_source.html">ActionsStack.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="a2ba3fc8906482ba474a1034a81d443c6"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int ActionsStack::GetNumber </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Get the number of available actions to execute. </p><dl class="section return"><dt>Returns</dt><dd>action number. </dd></dl>

<p class="definition">Definition at line <a class="el" href="ActionsStack_8cpp_source.html#l00078">78</a> of file <a class="el" href="ActionsStack_8cpp_source.html">ActionsStack.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="a92c898ac34971204c6da70234a9cd568"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classAction.html">Action</a> * ActionsStack::operator[] </td>
          <td>(</td>
          <td class="paramtype">unsigned char&#160;</td>
          <td class="paramname"><em>idx</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Array operator. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">idx</td><td>index of the action to get. </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="ActionsStack_8cpp_source.html#l00091">91</a> of file <a class="el" href="ActionsStack_8cpp_source.html">ActionsStack.cpp</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a class="anchor" id="a458994617bfbd0f8aee0fb93abcdb347"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">ActionsStack ActionsStack::Actions</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Static list of actions. </p>

<p class="definition">Definition at line <a class="el" href="ActionsStack_8hpp_source.html#l00069">69</a> of file <a class="el" href="ActionsStack_8hpp_source.html">ActionsStack.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="aef1d9742f23cad44c4e85e0cfdf942e9"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool ActionsStack::FillingStack</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>If this flag is false, the event are not added t the list. </p>

<p class="definition">Definition at line <a class="el" href="ActionsStack_8hpp_source.html#l00071">71</a> of file <a class="el" href="ActionsStack_8hpp_source.html">ActionsStack.hpp</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>D:/Mes documents/Trusty/Arduino/Libraries/Accessories/src/<a class="el" href="ActionsStack_8hpp_source.html">ActionsStack.hpp</a></li>
<li>D:/Mes documents/Trusty/Arduino/Libraries/Accessories/src/<a class="el" href="ActionsStack_8cpp_source.html">ActionsStack.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="classActionsStack.html">ActionsStack</a></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:44:46 for Accessories &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
